<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – Debugging</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="debugging">Debugging</h1>
<p>Cacti users sometimes complain about NaN's in their graphs. Unfortunately, there are several reasons for this result. The following is a step-by-step procedure recommended for debugging.</p>
<h2 id="check-cacti-log-file">Check Cacti Log File</h2>
<p>Your cacti log file should be located at <code>&lt;path_cacti&gt;/log/cacti.log</code>. If it is not, see <code>Settings</code>, <code>Paths</code>. Check for this kind of error:</p>
<pre class="console"><code>SPINE: Host[...] DS[....] WARNING: SNMP timeout detected [500 ms], ignoring host &#39;........&#39;
</code></pre>
<p>For "reasonable" timeouts, this may be related to a snmpbulkwalk issue. To change this, see <code>Settings</code>, <code>Poller</code> and lower the value for <code>The Maximum SNMP OIDs Per SNMP Get Request</code>. Start at a value of 2 and increase it again, if the poller starts working. (1 or less disables snmpbulkwalk) Some agent's don't have the horsepower to deliver that many OIDs at a time. Therefore, we can reduce the number for those older/under-powered devices.</p>
<h2 id="check-basic-data-gathering">Check Basic Data Gathering</h2>
<p>For scripts, run them as cactiuser from CLI to check basic functionality. E.g. for a Perl script named <code>your-perl-script.pl</code> with parameters "p1 p2" under *nix this would look like:</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb2-1" title="1"><span class="fu">su</span> - cactiuser</a>
<a class="sourceLine" id="cb2-2" title="2"><span class="ex">/full/path/to/perl</span> your-perl-script.pl p1 p2</a>
<a class="sourceLine" id="cb2-3" title="3"><span class="ex">...</span> (check output)</a></code></pre></div>
<p>For SNMP, snmpget the <em>exact</em> OID you're asking for, using same community string and SNMP version as defined within cacti. For an OID of <code>.1.3.6.1.4.something</code>, community string of <code>very-secret</code> and version 2 for target host <code>target-host</code> this would look like</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb3-1" title="1"><span class="ex">snmpget</span> -c very-secret -v 2c target-host .1.3.6.1.4.something</a>
<a class="sourceLine" id="cb3-2" title="2"><span class="ex">....</span> (check output)</a></code></pre></div>
<h2 id="check-cactis-poller">Check Cacti's poller</h2>
<p>First make sure that crontab always shows poller.php. This program will either call cmd.php, the PHP based poller <em>or</em> spine, the fast alternative, written in C. Define the poller you're using at <code>Settings</code>, <code>Poller</code>. Spine has to be implemented separately, it does not come with cacti by default.</p>
<p>Now, clear <code>./log/cacti.log</code> (or rename it to get a fresh start)</p>
<p>Then, change <code>Settings</code>, <code>Poller Logging Level</code> to DEBUG for <em>one</em> polling cycle. You may rename this log as well to avoid more stuff added to it with subsequent polling cycles.</p>
<p>Now, find the host/data source in question. The <code>Host[&lt;id&gt;]</code> is given numerically, the <code>&lt;id&gt;</code> being a specific number for that host. Find this <code>&lt;id&gt;</code> from the <code>Devices</code> menu when editing the host: The URL contains a string like</p>
<pre class="console"><code>id=&lt;id&gt;
</code></pre>
<p>Check, whether the output is as expected. If not, check your script (e.g. <code>/full/path/to/perl</code>). If OK, proceed to next step</p>
<p>This procedure may be replaced by running the poller manually for the failing host only. To do so, you need the <code>&lt;id&gt;</code>, again. If you're using cmd.php, set the DEBUG logging level as defined above and run</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb5-1" title="1"><span class="ex">php</span> -q cmd.php <span class="op">&lt;</span>id<span class="op">&gt;</span> <span class="op">&lt;</span>id<span class="op">&gt;</span></a></code></pre></div>
<p>If you're using spine, you may override logging level when calling the poller:</p>
<div class="sourceCode" id="cb6"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb6-1" title="1"><span class="ex">./spine</span> --verbosity=5 <span class="op">&lt;</span>id<span class="op">&gt;</span> <span class="op">&lt;</span>id<span class="op">&gt;</span></a></code></pre></div>
<p>All output is printed to STDOUT in both cases. This procedure allows for repeated tests without waiting for the next polling interval. And there's no need to manually search for the failing host between hundreds of lines of output.</p>
<h2 id="check-mysql-updating">Check MySQL updating</h2>
<p>In most cases, this step can be skipped. You may want to return to this step if the next one fails (e.g. no rrdtool update to be found)</p>
<p>From debug log, find the MySQL update statement for that host concerning table <code>poller_output</code>. On very rare occasions, this will fail. Copy that SQL statement and paste it to a MySQL session started from CLI. This may as well be done from some tool like phpMyAdmin. Check the SQL return code.</p>
<h2 id="check-rrdfile-updating">Check RRDfile updating</h2>
<p>Down in the same log, you should find some</p>
<div class="sourceCode" id="cb7"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb7-1" title="1"><span class="ex">rrdtool</span> update <span class="op">&lt;</span>filename<span class="op">&gt;</span> --template ...</a></code></pre></div>
<p>You should find exactly one update statement for each file.</p>
<p>RRDfiles should be created by the poller. If it does not create them, it will not fill them either. If it does check your <code>Poller Cache</code> from Utilities and search for your target. Does the query show up here?</p>
<h2 id="check-rrdfile-ownership">Check RRDfile ownership</h2>
<p>If RRDfiles were created e.g. with root ownership, a poller running as cactiuser will not be able to update those files</p>
<div class="sourceCode" id="cb8"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb8-1" title="1"><span class="bu">cd</span> /var/www/html/cacti/rra</a>
<a class="sourceLine" id="cb8-2" title="2"><span class="fu">ls</span> -l localhost*</a>
<a class="sourceLine" id="cb8-3" title="3"><span class="ex">-rw-r--r--</span>  1 root      root      463824 May 31 12:40 localhost_load_1min_5.rrd</a>
<a class="sourceLine" id="cb8-4" title="4"><span class="ex">-rw-r--r--</span>  1 cactiuser cactiuser 155584 Jun  1 17:10 localhost_mem_buffers_3.rrd</a>
<a class="sourceLine" id="cb8-5" title="5"><span class="ex">-rw-r--r--</span>  1 cactiuser cactiuser 155584 Jun  1 17:10 localhost_mem_swap_4.rrd</a>
<a class="sourceLine" id="cb8-6" title="6"><span class="ex">-rw-r--r--</span>  1 cactiuser cactiuser 155584 Jun  1 17:10 localhost_proc_7.rrd</a>
<a class="sourceLine" id="cb8-7" title="7"><span class="ex">-rw-r--r--</span>  1 cactiuser cactiuser 155584 Jun  1 17:10 localhost_users_6.rrd</a></code></pre></div>
<p>Run the following command to cure this problem</p>
<div class="sourceCode" id="cb9"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb9-1" title="1"><span class="fu">chown</span> cactiuser:cactiuser *.rrd</a></code></pre></div>
<h2 id="check-rrdfile-numbers">Check RRDfile numbers</h2>
<p>You're perhaps wondering about this step, if the former was OK. But due to data sources MINIMUM and MAXIMUM definitions, it is possible, that valid updates for RRDfiles are suppressed, because MINIMUM was not reached or MAXIMUM was exceeded.</p>
<p>Assuming, you've got some valid <code>rrdtool update</code> in step 3, perform a</p>
<div class="sourceCode" id="cb10"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb10-1" title="1"><span class="ex">rrdtool</span> fetch <span class="op">&lt;</span>RRDfile<span class="op">&gt;</span> AVERAGE</a></code></pre></div>
<p>and look at the last 10-20 lines. If you find NaN's there, perform</p>
<div class="sourceCode" id="cb11"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb11-1" title="1"><span class="ex">rrdtool</span> info <span class="op">&lt;</span>RRDfile<span class="op">&gt;</span></a></code></pre></div>
<p>and check the <code>ds[...].min</code> and <code>ds[...].max</code> entries, e.g.</p>
<div class="sourceCode" id="cb12"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb12-1" title="1"><span class="ex">ds</span>[loss].min = 0.0000000000e+00</a>
<a class="sourceLine" id="cb12-2" title="2"><span class="ex">ds</span>[loss].max = 1.0000000000e+02</a></code></pre></div>
<p>In this example, MINIMUM = 0 and MAXIMUM = 100. For a <code>ds.[...].type=GAUGE</code> verify, that e.g. the number returned by the script does not exceed <code>ds[...].MAX</code> (same holds for MINIMUM, respectively).</p>
<p>If you run into this, not only should you update the data source definition within the Data Template, but also perform a:</p>
<div class="sourceCode" id="cb13"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb13-1" title="1"><span class="ex">rrdtool</span> tune <span class="op">&lt;</span>RRDfile<span class="op">&gt;</span> --maximum <span class="op">&lt;</span>ds-name<span class="op">&gt;</span>:<span class="op">&lt;</span>new ds maximum<span class="op">&gt;</span></a></code></pre></div>
<p>for all existing RRDfiles belonging to that Data Template.</p>
<p>At this step, it is wise to check <code>step</code> and <code>heartbeat</code> of the RRDfile as well. For standard 300 seconds polling intervals (step=300), it is wise to set <code>minimal_heartbeat</code> to 600 seconds. If a single update is missing and the next one occurs in less than 600 seconds from the last one, RRDtool will interpolate the missing update. Thus, gaps are "filled" automatically by interpolation. Be aware of the fact, that this is no "real" data! Again, this must be done in the Data Template itself and by using <code>rrdtool tune</code> for all existing RRDfiles of this type.</p>
<h2 id="check-rrdtool-graph-statement">Check <code>rrdtool graph</code> statement</h2>
<p>Last resort would be to check, that the correct data sources are used. Go to <code>Graph Management</code> and select your Graph. Enable DEBUG Mode to find the whole <code>rrdtool graph</code> statement. You should notice the <code>DEF</code> statements. They specify the RRDfile and data source to be used. You may check, that all of them are as wanted.</p>
<h2 id="miscellaneous">Miscellaneous</h2>
<p>Up to current cacti 0.8.6h, table <code>poller_output</code> may increase beyond reasonable size.</p>
<p>This is commonly due to php.ini's memory settings of 8MB default. Change this to at least 64 MB.</p>
<p>To check this, run the following SQL from MySQL CLI (or phpMyAdmin or the like)</p>
<div class="sourceCode" id="cb14"><pre class="sourceCode sql"><code class="sourceCode sql"><a class="sourceLine" id="cb14-1" title="1"><span class="kw">select</span> <span class="fu">count</span>(<span class="op">*</span>) <span class="kw">from</span> poller_output;</a></code></pre></div>
<p>If the result is huge, you may get rid of those stuff by</p>
<div class="sourceCode" id="cb15"><pre class="sourceCode sql"><code class="sourceCode sql"><a class="sourceLine" id="cb15-1" title="1"><span class="kw">truncate</span> <span class="kw">table</span> poller_output;</a></code></pre></div>
<p>As of current SVN code for upcoming cacti 0.9, I saw measures were taken on both issues (memory size, truncating poller_output).</p>
<h2 id="rpm-installation">RPM Installation</h2>
<p>Most rpm installations will setup the crontab entry now. If you've followed the installation instructions to the letter (which you should always do ;-) ), you may now have two poller running. That's not a good thing, though. Most rpm installations will setup cron in <code>/etc/cron.d/cacti</code></p>
<p>Now check all your crontab, especially <code>/etc/crontab</code> and crontab of users root and cactiuser. Leave only one poller entry for all of them. Personally, I've chosen <code>/etc/cron.d/cacti</code> to avoid problems when updating RPM's. Most often, you won't remember this item when updating lots of RPM's, so I felt more secure to put it here. And I've made some slight modifications, see</p>
<div class="sourceCode" id="cb16"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb16-1" title="1"><span class="ex">shell</span><span class="op">&gt;</span> vi /etc/cron.d/cacti</a></code></pre></div>
<div class="sourceCode" id="cb17"><pre class="sourceCode ini"><code class="sourceCode ini"><a class="sourceLine" id="cb17-1" title="1"><span class="dt">*/5 * * * *     cactiuser       /usr/bin/php -q /var/www/html/cacti/poller.php &gt; /var/local/log/poller.log 2&gt;&amp;1</span></a></code></pre></div>
<p>This will produce a file <code>/var/local/log/poller.log</code>, which includes some additional informations from each poller's run, such as RRDtool errors. It occupies only some few bytes and will be overwritten each time.</p>
<p>If you're using the crontab of user "cactiuser" instead, this will look like</p>
<div class="sourceCode" id="cb18"><pre class="sourceCode sh"><code class="sourceCode bash"><a class="sourceLine" id="cb18-1" title="1"><span class="ex">shell</span><span class="op">&gt;</span> crontab -e -u cactiuser</a></code></pre></div>
<div class="sourceCode" id="cb19"><pre class="sourceCode ini"><code class="sourceCode ini"><a class="sourceLine" id="cb19-1" title="1"><span class="dt">*/5 * * * *     /usr/bin/php -q /var/www/html/cacti/poller.php &gt; /var/local/log/poller.log 2&gt;&amp;1</span></a></code></pre></div>
<h2 id="not-nan-but-0-zero-values">Not NaN, but 0 (zero) values</h2>
<p>Pay attention to custom scripts. It is required, that external commands called from there are in the <code>$PATH</code> of the cactiuser running the poller. It is therefor recommended to provide <code>/full/path/to/external/command</code></p>
<p>User "criggie" reported an issue with running smartctl. It was complaining "you are not root" so a quick <code>chmod +s</code> on the script fixed that problem.</p>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
